



(***************************************************)
(* Jose Luis Partida Sevillano                     *)
(***************************************************)


IMPLEMENTATION MODULE pelota;

FROM barra IMPORT Tbarra, posicionbarra;
FROM  Storage IMPORT Available, ALLOCATE, DEALLOCATE;
FROM Window IMPORT GotoXY;
FROM IO IMPORT WrChar;
FROM pantalla IMPORT tocarobstaculo, Ttabla;



TYPE
  Tpelota=POINTER TO bola;

  Tsentido=(arriba, abajo);
  Torienta=(derecha,izquierda);

  bola    = RECORD
              sentido:Tsentido;
              orientacion:Torienta;
              posicionX:CARDINAL;
              posicionY:CARDINAL;
            END;








PROCEDURE crearpelota(VAR pelot:Tpelota; VAR ok:BOOLEAN);
 BEGIN
   IF Available(SIZE(bola)) THEN
      NEW(pelot);
      pelot^.sentido:=arriba;
      pelot^.orientacion:=izquierda;
      pelot^.posicionX:=38;
      pelot^.posicionY:=16;
      ok:=TRUE;
   ELSE
      ok:=FALSE;
   END;

END crearpelota;





(*-------------------------------------------------------------------------*)







PROCEDURE visualizarpelota(pelot:Tpelota);
 BEGIN
    GotoXY(pelot^.posicionX+4, pelot^.posicionY+2); WrChar(CHR(9));
END visualizarpelota;







(*-------------------------------------------------------------------------*)



PROCEDURE posicionpelotaX(pelot:Tpelota):CARDINAL;
 BEGIN
   RETURN (pelot^.posicionX);
 END posicionpelotaX;




(*-------------------------------------------------------------------------*)


PROCEDURE posicionpelotaY(pelot:Tpelota):CARDINAL;
 BEGIN
   RETURN (pelot^.posicionY);
 END posicionpelotaY;



(*-------------------------------------------------------------------------*)




(* Compruebo si ha tocado alguna pared *)


PROCEDURE tocarparedes(pelot:Tpelota):BOOLEAN;
 BEGIN
   RETURN( (pelot^.posicionX=42) OR (pelot^.posicionX=1));

 END tocarparedes;



(*-------------------------------------------------------------------------*)



(* Compruebo si el jugadpr toca la pelota *)



PROCEDURE tocarbarra(pelot:Tpelota; bara:Tbarra):BOOLEAN;
 VAR
   toca:BOOLEAN;
 BEGIN
   toca:=FALSE;

   IF pelot^.posicionY=20 THEN
      toca:= ((pelot^.posicionX= posicionbarra(bara)) OR (pelot^.posicionX = posicionbarra(bara)+1) OR (pelot^.posicionX = posicionbarra(bara)+2)
                OR (pelot^.posicionX = posicionbarra(bara)+3) OR (pelot^.posicionX = posicionbarra(bara)+4) OR (pelot^.posicionX = posicionbarra(bara)+5));
   ELSE
      toca:=FALSE;
   END;
   RETURN(toca);

 END tocarbarra;





(*-------------------------------------------------------------------------*)




PROCEDURE tocartecho(pelot:Tpelota):BOOLEAN;
 BEGIN
   RETURN(pelot^.posicionY=1);
 END tocartecho;



(*-------------------------------------------------------------------------*)



(* Cambio de direccion cuando toca la pelota alguna pared *)



PROCEDURE cambiadireccion(VAR pelot:Tpelota);
 BEGIN
   IF pelot^.sentido=arriba THEN
      DEC(pelot^.posicionY);
      IF pelot^.orientacion=derecha THEN
         pelot^.orientacion:=izquierda;
         DEC(pelot^.posicionX);

      ELSE
         pelot^.orientacion:=derecha;
         INC(pelot^.posicionX);
      END;

   ELSE
      INC(pelot^.posicionY);
      IF pelot^.orientacion=derecha THEN
         pelot^.orientacion:=izquierda;
         INC(pelot^.posicionX);

      ELSE
         pelot^.orientacion:=derecha;
         DEC(pelot^.posicionX);

      END;
   END;

END cambiadireccion;




(*-------------------------------------------------------------------------*)





(* Cambio de direccion y de sentido cuando el jugador toca la pelota *)


PROCEDURE cambiadiresentido (VAR pelot:Tpelota);
 BEGIN
   pelot^.sentido:=arriba;
   DEC(pelot^.posicionY);
   IF pelot^.orientacion=izquierda THEN
      pelot^.orientacion:=derecha;
      INC(pelot^.posicionX);

   ELSE
      pelot^.orientacion:=izquierda;
      DEC(pelot^.posicionX);
   END;

END cambiadiresentido;




(*-------------------------------------------------------------------------*)



(* Cambio de direccion y de sentido cuando la pelota  toca el techo *)



PROCEDURE cambiadiresentido2 (VAR pelot:Tpelota);
 BEGIN
      pelot^.sentido:=abajo;
      INC(pelot^.posicionY);
      IF pelot^.orientacion=izquierda THEN
         pelot^.orientacion:=derecha;
      ELSE
         pelot^.orientacion:=izquierda;
      END;

END cambiadiresentido2;



(*-------------------------------------------------------------------------*)



(* Movemos la pelota segun las condiciones anteriores *)



PROCEDURE moverpelota(VAR pelot:Tpelota; bara:Tbarra);

 BEGIN
   IF tocarparedes(pelot) THEN
      cambiadireccion(pelot);

   ELSIF tocarbarra(pelot, bara) THEN
         cambiadiresentido(pelot);

   ELSIF tocartecho(pelot) THEN
         cambiadiresentido2(pelot);

   ELSE
      IF pelot^.sentido=arriba THEN
         IF pelot^.orientacion=derecha THEN
            INC(pelot^.posicionX);
            DEC(pelot^.posicionY);
         ELSE
            DEC(pelot^.posicionX);
            DEC(pelot^.posicionY);
         END;

      ELSE
         IF pelot^.orientacion=derecha THEN
            DEC(pelot^.posicionX);
            INC(pelot^.posicionY);
         ELSE
            INC(pelot^.posicionX);
            INC(pelot^.posicionY);
         END;
      END;
   END;


 END moverpelota;



(*-------------------------------------------------------------------------*)


(* Compruebo si el jugador pierde en el juego *)


PROCEDURE perder(pelot:Tpelota):BOOLEAN;
 BEGIN
    RETURN (pelot^.posicionY=22);
 END perder;



(*-------------------------------------------------------------------------*)




PROCEDURE destruirpelota(VAR pelot:Tpelota);
 BEGIN
   IF pelot#NIL THEN
      DISPOSE(pelot);
      pelot:=NIL;
   END;

END destruirpelota;



END pelota.